<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.3"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>NANO102/112 BSP: Device/Nuvoton/Nano1X2Series/Source/system_Nano1X2Series.c Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="../../M0Banner_v2.jpg"/></td>
  <td id="projectalign">
   <div id="projectname">NANO102/112 BSP<span id="projectnumber">&#160;V3.04.000</span>
   </div>
   <div id="projectbrief">The Board Support Package for Nano102/112 Series</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.3 -->
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('../../',false,false,'search.php','Search');
});
/* @license-end */
</script>
<div id="main-nav"></div>
<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="../../dir_4c76ddfc10a27668d6c42d3412320ee0.html">Device</a></li><li class="navelem"><a class="el" href="../../dir_dfa946205a9a0ffc7bda9b97689fa4ff.html">Nuvoton</a></li><li class="navelem"><a class="el" href="../../dir_92781df0a275b97b29ea05f684c53720.html">Nano1X2Series</a></li><li class="navelem"><a class="el" href="../../dir_a9675d3fe69a6956120b6eac8ec66ca6.html">Source</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle"><div class="title">system_Nano1X2Series.c</div></div>
</div><!--header-->
<div class="contents">
<a href="../../d5/d7e/system___nano1_x2_series_8c.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/******************************************************************************</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment"> * @file     system_Nano1X2Series.c</span></div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment"> * @version  V1.00</span></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment"> * $Revision: 6 $</span></div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="comment"> * $Date: 13/12/16 4:27p $</span></div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="comment"> * @brief    Nano1X2 series system clock init code and assert handler</span></div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span><span class="comment"> *</span></div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span><span class="comment"> * @note</span></div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span><span class="comment"> * SPDX-License-Identifier: Apache-2.0</span></div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span><span class="comment"> * Copyright (C) 2013 Nuvoton Technology Corp. All rights reserved.</span></div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span><span class="comment">*****************************************************************************/</span></div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span> </div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span><span class="preprocessor">#include &lt;stdint.h&gt;</span></div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span><span class="preprocessor">#include &quot;<a class="code" href="../../da/d91/_nano1_x2_series_8h.html">Nano1X2Series.h</a>&quot;</span></div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span> </div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span> </div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span><span class="comment">/*----------------------------------------------------------------------------</span></div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span><span class="comment">  Clock Variable definitions</span></div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span><span class="comment"> *----------------------------------------------------------------------------*/</span></div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno"><a class="line" href="../../d9/dd8/system___nano1_x2_series_8h.html#aa3cd3e43291e81e795d642b79b6088e6">   20</a></span>uint32_t <a class="code hl_variable" href="../../d5/d7e/system___nano1_x2_series_8c.html#aa3cd3e43291e81e795d642b79b6088e6">SystemCoreClock</a>  = <a class="code hl_define" href="../../d9/dd8/system___nano1_x2_series_8h.html#abbd628d8a30e6695b3715ae72a693e56">__HSI</a>;              </div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno"><a class="line" href="../../d9/dd8/system___nano1_x2_series_8h.html#a63bedf89ae7fbb102b8653aca20d3a14">   21</a></span>uint32_t <a class="code hl_variable" href="../../d5/d7e/system___nano1_x2_series_8c.html#a63bedf89ae7fbb102b8653aca20d3a14">CyclesPerUs</a>      = (<a class="code hl_define" href="../../d9/dd8/system___nano1_x2_series_8h.html#abbd628d8a30e6695b3715ae72a693e56">__HSI</a> / 1000000);  </div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno"><a class="line" href="../../d9/dd8/system___nano1_x2_series_8h.html#ad0eab36ae6ce25e23219dc6a1e8fa73a">   28</a></span>uint32_t <a class="code hl_function" href="../../dc/d49/group___n_a_n_o1_x2___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gad0eab36ae6ce25e23219dc6a1e8fa73a">SysGet_PLLClockFreq</a>(<span class="keywordtype">void</span>)</div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span>{</div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span>    uint32_t u32Freq =0, u32PLLSrc;</div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span>    uint32_t u32SRC_N,u32PLL_M,u32PllReg;</div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno">   32</span> </div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span>    u32PllReg = <a class="code hl_define" href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga4b355291fe6b8ba8e167ab0faa862e45">CLK</a>-&gt;PLLCTL;</div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno">   34</span> </div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span>    <span class="keywordflow">if</span> (u32PllReg &amp; <a class="code hl_define" href="../../d5/d2d/group___n_a_n_o1_x2___c_l_k___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#gaa9c2de1d08b46cc9e870089791dfb248">CLK_PLLCTL_PD</a>)</div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span>        <span class="keywordflow">return</span> 0;    <span class="comment">/* PLL is in power down mode */</span></div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno">   37</span> </div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span>    <span class="keywordflow">if</span> (u32PllReg &amp; <a class="code hl_define" href="../../d5/d2d/group___n_a_n_o1_x2___c_l_k___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#ga781435991b8a07e0951b23be1beadeea">CLK_PLLCTL_PLL_SRC_HIRC</a>)</div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span>    {</div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno">   40</span>        <span class="keywordflow">if</span>(<a class="code hl_define" href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga4b355291fe6b8ba8e167ab0faa862e45">CLK</a>-&gt;PLLCTL &amp; <a class="code hl_define" href="../../da/d80/group___n_a_n_o1_x2___definitions.html#gac3544758fe7062fa3b3246b1ae15f60b">CLK_PWRCTL_HIRC_FSEL_Msk</a>)</div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno">   41</span>            u32PLLSrc =<a class="code hl_define" href="../../d9/dd8/system___nano1_x2_series_8h.html#aae5c5ec4722a291e1271743d45414223">__HIRC16M</a>;</div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno">   42</span>        <span class="keywordflow">else</span></div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno">   43</span>            u32PLLSrc =<a class="code hl_define" href="../../d9/dd8/system___nano1_x2_series_8h.html#ad145c32431f633b887d84ef0c78f42f3">__HIRC12M</a>;</div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno">   44</span>    }</div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno">   45</span>    <span class="keywordflow">else</span></div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno">   46</span>        u32PLLSrc = <a class="code hl_define" href="../../d9/dd8/system___nano1_x2_series_8h.html#a37c1644396b5996e92902bbf2dfc3ec5">__HXT</a>;</div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno">   47</span> </div>
<div class="line"><a id="l00048" name="l00048"></a><span class="lineno">   48</span>    u32SRC_N = (u32PllReg &amp; <a class="code hl_define" href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga09faedb598544a2c79f578166316d598">CLK_PLLCTL_PLL_SRC_N_Msk</a>) &gt;&gt; <a class="code hl_define" href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga2a0518052c2502874262756399f97e15">CLK_PLLCTL_PLL_SRC_N_Pos</a>;</div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno">   49</span>    u32PLL_M = (u32PllReg &amp; <a class="code hl_define" href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga09eb268c3a774033a1147513ede28135">CLK_PLLCTL_PLL_MLP_Msk</a>) &gt;&gt; <a class="code hl_define" href="../../da/d80/group___n_a_n_o1_x2___definitions.html#gac3008f57e3fdb122dc36be635f89fbee">CLK_PLLCTL_PLL_MLP_Pos</a>;</div>
<div class="line"><a id="l00050" name="l00050"></a><span class="lineno">   50</span> </div>
<div class="line"><a id="l00051" name="l00051"></a><span class="lineno">   51</span>    u32Freq = u32PLLSrc * u32PLL_M / (u32SRC_N+1);</div>
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno">   52</span> </div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span>    <span class="keywordflow">return</span> u32Freq;</div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span>}</div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span> </div>
<div class="line"><a id="l00056" name="l00056"></a><span class="lineno">   56</span> </div>
<div class="line"><a id="l00062" name="l00062"></a><span class="lineno"><a class="line" href="../../d5/d7e/system___nano1_x2_series_8c.html#aca6d5b465c5468d7dc1f3675e834c1b9">   62</a></span>uint32_t <a class="code hl_function" href="../../d5/d7e/system___nano1_x2_series_8c.html#aca6d5b465c5468d7dc1f3675e834c1b9">SysGet_HCLKFreq</a>(<span class="keywordtype">void</span>)</div>
<div class="line"><a id="l00063" name="l00063"></a><span class="lineno">   63</span>{</div>
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span> </div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span>    uint32_t u32Freqout, u32AHBDivider, u32ClkSel;</div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span> </div>
<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span>    u32ClkSel = <a class="code hl_define" href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga4b355291fe6b8ba8e167ab0faa862e45">CLK</a>-&gt;CLKSEL0 &amp; <a class="code hl_define" href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga2b0b9da2546b63f8a826d81e604948c2">CLK_CLKSEL0_HCLK_S_Msk</a>;</div>
<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span> </div>
<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span>    <span class="keywordflow">if</span> (u32ClkSel == <a class="code hl_define" href="../../d5/d2d/group___n_a_n_o1_x2___c_l_k___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#ga8960bacee034e54d5885fe0b1106c4ec">CLK_CLKSEL0_HCLK_S_HXT</a>)    <span class="comment">/* external HXT crystal clock */</span></div>
<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span>    {</div>
<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span>        u32Freqout = <a class="code hl_define" href="../../d9/dd8/system___nano1_x2_series_8h.html#a37c1644396b5996e92902bbf2dfc3ec5">__HXT</a>;</div>
<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span>    }</div>
<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span>    <span class="keywordflow">else</span> <span class="keywordflow">if</span>(u32ClkSel == <a class="code hl_define" href="../../d5/d2d/group___n_a_n_o1_x2___c_l_k___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#ga4b2d4325fe63925bc8d2a962a91bc962">CLK_CLKSEL0_HCLK_S_LXT</a>)        <span class="comment">/* external LXT crystal clock */</span></div>
<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span>    {</div>
<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span>        u32Freqout = <a class="code hl_define" href="../../d9/dd8/system___nano1_x2_series_8h.html#ab781074cbf310ee17748083dbe36ae98">__LXT</a>;</div>
<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span>    }</div>
<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span>    <span class="keywordflow">else</span> <span class="keywordflow">if</span>(u32ClkSel == <a class="code hl_define" href="../../d5/d2d/group___n_a_n_o1_x2___c_l_k___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#gab3399b4fa416b9e84a25040adf4b3a8c">CLK_CLKSEL0_HCLK_S_PLL</a>)        <span class="comment">/* PLL clock */</span></div>
<div class="line"><a id="l00078" name="l00078"></a><span class="lineno">   78</span>    {</div>
<div class="line"><a id="l00079" name="l00079"></a><span class="lineno">   79</span>        u32Freqout = <a class="code hl_function" href="../../dc/d49/group___n_a_n_o1_x2___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gad0eab36ae6ce25e23219dc6a1e8fa73a">SysGet_PLLClockFreq</a>();</div>
<div class="line"><a id="l00080" name="l00080"></a><span class="lineno">   80</span>    }</div>
<div class="line"><a id="l00081" name="l00081"></a><span class="lineno">   81</span>    <span class="keywordflow">else</span> <span class="keywordflow">if</span>(u32ClkSel == <a class="code hl_define" href="../../d5/d2d/group___n_a_n_o1_x2___c_l_k___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#gafbbe76abb6aba125cdee4bc334de5df3">CLK_CLKSEL0_HCLK_S_LIRC</a>)     <span class="comment">/* internal LIRC oscillator clock */</span></div>
<div class="line"><a id="l00082" name="l00082"></a><span class="lineno">   82</span>    {</div>
<div class="line"><a id="l00083" name="l00083"></a><span class="lineno">   83</span>        u32Freqout = <a class="code hl_define" href="../../d9/dd8/system___nano1_x2_series_8h.html#a6f446dd2f087f409b4fc986c0c25c2a9">__LIRC</a>;</div>
<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span>    }</div>
<div class="line"><a id="l00085" name="l00085"></a><span class="lineno">   85</span>    <span class="keywordflow">else</span>                                    <span class="comment">/* internal HIRC oscillator clock */</span></div>
<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span>    {</div>
<div class="line"><a id="l00087" name="l00087"></a><span class="lineno">   87</span>        <span class="keywordflow">if</span>((<a class="code hl_define" href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga4b355291fe6b8ba8e167ab0faa862e45">CLK</a>-&gt;PWRCTL &amp; <a class="code hl_define" href="../../da/d80/group___n_a_n_o1_x2___definitions.html#gac3544758fe7062fa3b3246b1ae15f60b">CLK_PWRCTL_HIRC_FSEL_Msk</a>) == <a class="code hl_define" href="../../da/d80/group___n_a_n_o1_x2___definitions.html#gac3544758fe7062fa3b3246b1ae15f60b">CLK_PWRCTL_HIRC_FSEL_Msk</a>)</div>
<div class="line"><a id="l00088" name="l00088"></a><span class="lineno">   88</span>            u32Freqout = <a class="code hl_define" href="../../d9/dd8/system___nano1_x2_series_8h.html#aae5c5ec4722a291e1271743d45414223">__HIRC16M</a>;</div>
<div class="line"><a id="l00089" name="l00089"></a><span class="lineno">   89</span>        <span class="keywordflow">else</span></div>
<div class="line"><a id="l00090" name="l00090"></a><span class="lineno">   90</span>            u32Freqout = <a class="code hl_define" href="../../d9/dd8/system___nano1_x2_series_8h.html#ad145c32431f633b887d84ef0c78f42f3">__HIRC12M</a>;</div>
<div class="line"><a id="l00091" name="l00091"></a><span class="lineno">   91</span> </div>
<div class="line"><a id="l00092" name="l00092"></a><span class="lineno">   92</span>    }</div>
<div class="line"><a id="l00093" name="l00093"></a><span class="lineno">   93</span>    u32AHBDivider = (<a class="code hl_define" href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga4b355291fe6b8ba8e167ab0faa862e45">CLK</a>-&gt;CLKDIV0 &amp; <a class="code hl_define" href="../../da/d80/group___n_a_n_o1_x2___definitions.html#gabc063298172f123ecf062108faa63136">CLK_CLKDIV0_HCLK_N_Msk</a>) + 1 ;</div>
<div class="line"><a id="l00094" name="l00094"></a><span class="lineno">   94</span> </div>
<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span>    <span class="keywordflow">return</span> (u32Freqout/u32AHBDivider);</div>
<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span>}</div>
<div class="line"><a id="l00097" name="l00097"></a><span class="lineno">   97</span> </div>
<div class="line"><a id="l00098" name="l00098"></a><span class="lineno">   98</span> </div>
<div class="line"><a id="l00106" name="l00106"></a><span class="lineno"><a class="line" href="../../d9/dd8/system___nano1_x2_series_8h.html#ae0c36a9591fe6e9c45ecb21a794f0f0f">  106</a></span><span class="keywordtype">void</span> <a class="code hl_function" href="../../d5/d7e/system___nano1_x2_series_8c.html#ae0c36a9591fe6e9c45ecb21a794f0f0f">SystemCoreClockUpdate</a> (<span class="keywordtype">void</span>)</div>
<div class="line"><a id="l00107" name="l00107"></a><span class="lineno">  107</span>{</div>
<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span> </div>
<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span>    <a class="code hl_variable" href="../../d5/d7e/system___nano1_x2_series_8c.html#aa3cd3e43291e81e795d642b79b6088e6">SystemCoreClock</a> = <a class="code hl_function" href="../../d5/d7e/system___nano1_x2_series_8c.html#aca6d5b465c5468d7dc1f3675e834c1b9">SysGet_HCLKFreq</a>();</div>
<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span>    <a class="code hl_variable" href="../../d5/d7e/system___nano1_x2_series_8c.html#a63bedf89ae7fbb102b8653aca20d3a14">CyclesPerUs</a> = (<a class="code hl_variable" href="../../d5/d7e/system___nano1_x2_series_8c.html#aa3cd3e43291e81e795d642b79b6088e6">SystemCoreClock</a> + 500000) / 1000000;</div>
<div class="line"><a id="l00111" name="l00111"></a><span class="lineno">  111</span>}</div>
<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span> </div>
<div class="line"><a id="l00113" name="l00113"></a><span class="lineno">  113</span><span class="preprocessor">#if USE_ASSERT</span></div>
<div class="line"><a id="l00114" name="l00114"></a><span class="lineno">  114</span> </div>
<div class="line"><a id="l00126" name="l00126"></a><span class="lineno">  126</span><span class="keywordtype">void</span> AssertError(uint8_t * file, uint32_t line)</div>
<div class="line"><a id="l00127" name="l00127"></a><span class="lineno">  127</span>{</div>
<div class="line"><a id="l00128" name="l00128"></a><span class="lineno">  128</span> </div>
<div class="line"><a id="l00129" name="l00129"></a><span class="lineno">  129</span>    printf(<span class="stringliteral">&quot;[%s] line %d : wrong parameters.\r\n&quot;</span>, file, line);</div>
<div class="line"><a id="l00130" name="l00130"></a><span class="lineno">  130</span> </div>
<div class="line"><a id="l00131" name="l00131"></a><span class="lineno">  131</span>    <span class="comment">/* Infinite loop */</span></div>
<div class="line"><a id="l00132" name="l00132"></a><span class="lineno">  132</span>    <span class="keywordflow">while</span>(1) ;</div>
<div class="line"><a id="l00133" name="l00133"></a><span class="lineno">  133</span>}</div>
<div class="line"><a id="l00134" name="l00134"></a><span class="lineno">  134</span><span class="preprocessor">#endif</span></div>
<div class="line"><a id="l00135" name="l00135"></a><span class="lineno">  135</span> </div>
<div class="line"><a id="l00136" name="l00136"></a><span class="lineno">  136</span><span class="comment">/*** (C) COPYRIGHT 2013 Nuvoton Technology Corp. ***/</span></div>
<div class="ttc" id="a_nano1_x2_series_8h_html"><div class="ttname"><a href="../../da/d91/_nano1_x2_series_8h.html">Nano1X2Series.h</a></div><div class="ttdoc">Nano102/112 peripheral access layer header file. This file contains all the peripheral register's def...</div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___c_l_k___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s_html_ga4b2d4325fe63925bc8d2a962a91bc962"><div class="ttname"><a href="../../d5/d2d/group___n_a_n_o1_x2___c_l_k___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#ga4b2d4325fe63925bc8d2a962a91bc962">CLK_CLKSEL0_HCLK_S_LXT</a></div><div class="ttdeci">#define CLK_CLKSEL0_HCLK_S_LXT</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d89/clk_8h_source.html#l00123">clk.h:123</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___c_l_k___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s_html_ga781435991b8a07e0951b23be1beadeea"><div class="ttname"><a href="../../d5/d2d/group___n_a_n_o1_x2___c_l_k___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#ga781435991b8a07e0951b23be1beadeea">CLK_PLLCTL_PLL_SRC_HIRC</a></div><div class="ttdeci">#define CLK_PLLCTL_PLL_SRC_HIRC</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d89/clk_8h_source.html#l00099">clk.h:99</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___c_l_k___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s_html_ga8960bacee034e54d5885fe0b1106c4ec"><div class="ttname"><a href="../../d5/d2d/group___n_a_n_o1_x2___c_l_k___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#ga8960bacee034e54d5885fe0b1106c4ec">CLK_CLKSEL0_HCLK_S_HXT</a></div><div class="ttdeci">#define CLK_CLKSEL0_HCLK_S_HXT</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d89/clk_8h_source.html#l00122">clk.h:122</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___c_l_k___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s_html_gaa9c2de1d08b46cc9e870089791dfb248"><div class="ttname"><a href="../../d5/d2d/group___n_a_n_o1_x2___c_l_k___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#gaa9c2de1d08b46cc9e870089791dfb248">CLK_PLLCTL_PD</a></div><div class="ttdeci">#define CLK_PLLCTL_PD</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d89/clk_8h_source.html#l00097">clk.h:97</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___c_l_k___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s_html_gab3399b4fa416b9e84a25040adf4b3a8c"><div class="ttname"><a href="../../d5/d2d/group___n_a_n_o1_x2___c_l_k___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#gab3399b4fa416b9e84a25040adf4b3a8c">CLK_CLKSEL0_HCLK_S_PLL</a></div><div class="ttdeci">#define CLK_CLKSEL0_HCLK_S_PLL</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d89/clk_8h_source.html#l00124">clk.h:124</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___c_l_k___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s_html_gafbbe76abb6aba125cdee4bc334de5df3"><div class="ttname"><a href="../../d5/d2d/group___n_a_n_o1_x2___c_l_k___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#gafbbe76abb6aba125cdee4bc334de5df3">CLK_CLKSEL0_HCLK_S_LIRC</a></div><div class="ttdeci">#define CLK_CLKSEL0_HCLK_S_LIRC</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d89/clk_8h_source.html#l00125">clk.h:125</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___definitions_html_ga09eb268c3a774033a1147513ede28135"><div class="ttname"><a href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga09eb268c3a774033a1147513ede28135">CLK_PLLCTL_PLL_MLP_Msk</a></div><div class="ttdeci">#define CLK_PLLCTL_PLL_MLP_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l01643">Nano1X2Series.h:1643</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___definitions_html_ga09faedb598544a2c79f578166316d598"><div class="ttname"><a href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga09faedb598544a2c79f578166316d598">CLK_PLLCTL_PLL_SRC_N_Msk</a></div><div class="ttdeci">#define CLK_PLLCTL_PLL_SRC_N_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l01646">Nano1X2Series.h:1646</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___definitions_html_ga2a0518052c2502874262756399f97e15"><div class="ttname"><a href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga2a0518052c2502874262756399f97e15">CLK_PLLCTL_PLL_SRC_N_Pos</a></div><div class="ttdeci">#define CLK_PLLCTL_PLL_SRC_N_Pos</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l01645">Nano1X2Series.h:1645</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___definitions_html_ga2b0b9da2546b63f8a826d81e604948c2"><div class="ttname"><a href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga2b0b9da2546b63f8a826d81e604948c2">CLK_CLKSEL0_HCLK_S_Msk</a></div><div class="ttdeci">#define CLK_CLKSEL0_HCLK_S_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l01571">Nano1X2Series.h:1571</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___definitions_html_gabc063298172f123ecf062108faa63136"><div class="ttname"><a href="../../da/d80/group___n_a_n_o1_x2___definitions.html#gabc063298172f123ecf062108faa63136">CLK_CLKDIV0_HCLK_N_Msk</a></div><div class="ttdeci">#define CLK_CLKDIV0_HCLK_N_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l01616">Nano1X2Series.h:1616</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___definitions_html_gac3008f57e3fdb122dc36be635f89fbee"><div class="ttname"><a href="../../da/d80/group___n_a_n_o1_x2___definitions.html#gac3008f57e3fdb122dc36be635f89fbee">CLK_PLLCTL_PLL_MLP_Pos</a></div><div class="ttdeci">#define CLK_PLLCTL_PLL_MLP_Pos</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l01642">Nano1X2Series.h:1642</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___definitions_html_gac3544758fe7062fa3b3246b1ae15f60b"><div class="ttname"><a href="../../da/d80/group___n_a_n_o1_x2___definitions.html#gac3544758fe7062fa3b3246b1ae15f60b">CLK_PWRCTL_HIRC_FSEL_Msk</a></div><div class="ttdeci">#define CLK_PWRCTL_HIRC_FSEL_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l01469">Nano1X2Series.h:1469</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n_html_ga4b355291fe6b8ba8e167ab0faa862e45"><div class="ttname"><a href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga4b355291fe6b8ba8e167ab0faa862e45">CLK</a></div><div class="ttdeci">#define CLK</div><div class="ttdoc">Pointer to CLK register structure.</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l10651">Nano1X2Series.h:10651</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_gad0eab36ae6ce25e23219dc6a1e8fa73a"><div class="ttname"><a href="../../dc/d49/group___n_a_n_o1_x2___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gad0eab36ae6ce25e23219dc6a1e8fa73a">SysGet_PLLClockFreq</a></div><div class="ttdeci">uint32_t SysGet_PLLClockFreq(void)</div><div class="ttdoc">Calculate current PLL clock frequency.</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d7e/system___nano1_x2_series_8c_source.html#l00028">system_Nano1X2Series.c:28</a></div></div>
<div class="ttc" id="asystem___nano1_x2_series_8c_html_a63bedf89ae7fbb102b8653aca20d3a14"><div class="ttname"><a href="../../d5/d7e/system___nano1_x2_series_8c.html#a63bedf89ae7fbb102b8653aca20d3a14">CyclesPerUs</a></div><div class="ttdeci">uint32_t CyclesPerUs</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d7e/system___nano1_x2_series_8c_source.html#l00021">system_Nano1X2Series.c:21</a></div></div>
<div class="ttc" id="asystem___nano1_x2_series_8c_html_aa3cd3e43291e81e795d642b79b6088e6"><div class="ttname"><a href="../../d5/d7e/system___nano1_x2_series_8c.html#aa3cd3e43291e81e795d642b79b6088e6">SystemCoreClock</a></div><div class="ttdeci">uint32_t SystemCoreClock</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d7e/system___nano1_x2_series_8c_source.html#l00020">system_Nano1X2Series.c:20</a></div></div>
<div class="ttc" id="asystem___nano1_x2_series_8c_html_aca6d5b465c5468d7dc1f3675e834c1b9"><div class="ttname"><a href="../../d5/d7e/system___nano1_x2_series_8c.html#aca6d5b465c5468d7dc1f3675e834c1b9">SysGet_HCLKFreq</a></div><div class="ttdeci">uint32_t SysGet_HCLKFreq(void)</div><div class="ttdoc">Get current HCLK clock frequency.</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d7e/system___nano1_x2_series_8c_source.html#l00062">system_Nano1X2Series.c:62</a></div></div>
<div class="ttc" id="asystem___nano1_x2_series_8c_html_ae0c36a9591fe6e9c45ecb21a794f0f0f"><div class="ttname"><a href="../../d5/d7e/system___nano1_x2_series_8c.html#ae0c36a9591fe6e9c45ecb21a794f0f0f">SystemCoreClockUpdate</a></div><div class="ttdeci">void SystemCoreClockUpdate(void)</div><div class="ttdoc">This function is used to update the variable SystemCoreClock and must be called whenever the core clo...</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d7e/system___nano1_x2_series_8c_source.html#l00106">system_Nano1X2Series.c:106</a></div></div>
<div class="ttc" id="asystem___nano1_x2_series_8h_html_a37c1644396b5996e92902bbf2dfc3ec5"><div class="ttname"><a href="../../d9/dd8/system___nano1_x2_series_8h.html#a37c1644396b5996e92902bbf2dfc3ec5">__HXT</a></div><div class="ttdeci">#define __HXT</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/dd8/system___nano1_x2_series_8h_source.html#l00026">system_Nano1X2Series.h:26</a></div></div>
<div class="ttc" id="asystem___nano1_x2_series_8h_html_a6f446dd2f087f409b4fc986c0c25c2a9"><div class="ttname"><a href="../../d9/dd8/system___nano1_x2_series_8h.html#a6f446dd2f087f409b4fc986c0c25c2a9">__LIRC</a></div><div class="ttdeci">#define __LIRC</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/dd8/system___nano1_x2_series_8h_source.html#l00030">system_Nano1X2Series.h:30</a></div></div>
<div class="ttc" id="asystem___nano1_x2_series_8h_html_aae5c5ec4722a291e1271743d45414223"><div class="ttname"><a href="../../d9/dd8/system___nano1_x2_series_8h.html#aae5c5ec4722a291e1271743d45414223">__HIRC16M</a></div><div class="ttdeci">#define __HIRC16M</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/dd8/system___nano1_x2_series_8h_source.html#l00029">system_Nano1X2Series.h:29</a></div></div>
<div class="ttc" id="asystem___nano1_x2_series_8h_html_ab781074cbf310ee17748083dbe36ae98"><div class="ttname"><a href="../../d9/dd8/system___nano1_x2_series_8h.html#ab781074cbf310ee17748083dbe36ae98">__LXT</a></div><div class="ttdeci">#define __LXT</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/dd8/system___nano1_x2_series_8h_source.html#l00027">system_Nano1X2Series.h:27</a></div></div>
<div class="ttc" id="asystem___nano1_x2_series_8h_html_abbd628d8a30e6695b3715ae72a693e56"><div class="ttname"><a href="../../d9/dd8/system___nano1_x2_series_8h.html#abbd628d8a30e6695b3715ae72a693e56">__HSI</a></div><div class="ttdeci">#define __HSI</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/dd8/system___nano1_x2_series_8h_source.html#l00032">system_Nano1X2Series.h:32</a></div></div>
<div class="ttc" id="asystem___nano1_x2_series_8h_html_ad145c32431f633b887d84ef0c78f42f3"><div class="ttname"><a href="../../d9/dd8/system___nano1_x2_series_8h.html#ad145c32431f633b887d84ef0c78f42f3">__HIRC12M</a></div><div class="ttdeci">#define __HIRC12M</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/dd8/system___nano1_x2_series_8h_source.html#l00028">system_Nano1X2Series.h:28</a></div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Fri Oct 18 2024 12:20:30 for NANO102/112 BSP by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.3
</small></address>
</body>
</html>
